CreatorProperty (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.deser.impl

## Class CreatorProperty

- java.lang.Object
- - org.codehaus.jackson.map.deser.SettableBeanProperty
  - - org.codehaus.jackson.map.deser.impl.CreatorProperty

- All Implemented Interfaces:
    BeanProperty, Named

      public class CreatorProperty
      extends SettableBeanProperty

  This concrete sub-class implements property that is passed via Creator (constructor or static factory method). It is not a full-featured implementation in that its set method should never be called -- instead, value must separately passed.

  Note on injectable values (1.9): unlike with other mutators, where deserializer and injecting are separate, here we deal the two as related things. This is necessary to add proper priority, as well as to simplify coordination.

  Note that this class was moved in Jackson 1.9 from being a static sub-class of "org.codehaus.jackson.map.deser.SettableBeanProperty" into separate class, to make it easier to use it for custom creators.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.deser.SettableBeanProperty

      `SettableBeanProperty.FieldProperty, SettableBeanProperty.InnerClassProperty, SettableBeanProperty.ManagedReferenceProperty, SettableBeanProperty.MethodProperty, SettableBeanProperty.NullProvider, SettableBeanProperty.SetterlessProperty`

    - ### Nested classes/interfaces inherited from interface org.codehaus.jackson.map.BeanProperty

      `BeanProperty.Std`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected AnnotatedParameter` | `_annotated` Placeholder that represents constructor parameter, when it is created from actual constructor.
    `protected Object` | `_injectableValueId` Id of value to inject, if value injection should be used for this parameter (in addition to, or instead of, regular deserialization).

    - ### Fields inherited from class org.codehaus.jackson.map.deser.SettableBeanProperty

      `_contextAnnotations, _managedReferenceName, _nullProvider, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `CreatorProperty(CreatorProperty src, JsonDeserializer<Object> deser)`
    `` | `CreatorProperty(String name, JavaType type, TypeDeserializer typeDeser, Annotations contextAnnotations, AnnotatedParameter param, int index, Object injectableValueId)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `deserializeAndSet(JsonParser jp, DeserializationContext ctxt, Object instance)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.
    `Object` | `findInjectableValue(DeserializationContext context, Object beanInstance)` Method that can be called to locate value to be injected for this property, if it is configured for this.
    `<A extends Annotation> A` | `getAnnotation(Class<A> acls)` Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
    `Object` | `getInjectableValueId()` Accessor for id of injectable value, if this bean property supports value injection.
    `AnnotatedMember` | `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
    `void` | `inject(DeserializationContext context, Object beanInstance)` Method to find value to inject, and inject it to this property.
    `void` | `set(Object instance, Object value)`
    `CreatorProperty` | `withValueDeserializer(JsonDeserializer<Object> deser)`

    - ### Methods inherited from class org.codehaus.jackson.map.deser.SettableBeanProperty

      `_throwAsIOE, _throwAsIOE, assignIndex, deserialize, getContextAnnotation, getDeclaringClass, getManagedReferenceName, getName, getPropertyIndex, getPropertyName, getProperytIndex, getType, getValueDeserializer, getValueTypeDeserializer, hasValueDeserializer, hasValueTypeDeserializer, setManagedReferenceName, setValueDeserializer, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### _annotated

          protected final AnnotatedParameter _annotated

      Placeholder that represents constructor parameter, when it is created from actual constructor. May be null when a synthetic instance is created.

    - #### _injectableValueId

          protected final Object _injectableValueId

      Id of value to inject, if value injection should be used for this parameter (in addition to, or instead of, regular deserialization).
      Since:
        1.9

  - ### Constructor Detail

    - #### CreatorProperty

          public CreatorProperty(String name,
                         JavaType type,
                         TypeDeserializer typeDeser,
                         Annotations contextAnnotations,
                         AnnotatedParameter param,
                         int index,
                         Object injectableValueId)

      Parameters:
        `name` - Name of the logical property
        `type` - Type of the property, used to find deserializer
        `typeDeser` - Type deserializer to use for handling polymorphic type information, if one is needed
        `contextAnnotations` - Contextual annotations (usually by class that declares creator [constructor, factory method] that includes this property)
        `param` - Representation of property, constructor or factory method parameter; used for accessing annotations of the property

    - #### CreatorProperty

          protected CreatorProperty(CreatorProperty src,
                         JsonDeserializer<Object> deser)

  - ### Method Detail

    - #### withValueDeserializer

          public CreatorProperty withValueDeserializer(JsonDeserializer<Object> deser)

      Specified by:
        `withValueDeserializer` in class `SettableBeanProperty`

    - #### findInjectableValue

          public Object findInjectableValue(DeserializationContext context,
                                   Object beanInstance)

      Method that can be called to locate value to be injected for this property, if it is configured for this.
      Since:
        1.9

    - #### inject

          public void inject(DeserializationContext context,
                    Object beanInstance)
                      throws IOException

      Method to find value to inject, and inject it to this property.
      Throws:
        `IOException`
      Since:
        1.9

    - #### getAnnotation

          public <A extends Annotation> A getAnnotation(Class<A> acls)

      Description copied from interface: `BeanProperty`
      Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
      Specified by:
        `getAnnotation` in interface `BeanProperty`
      Specified by:
        `getAnnotation` in class `SettableBeanProperty`

    - #### getMember

          public AnnotatedMember getMember()

      Description copied from interface: `BeanProperty`
      Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
      Specified by:
        `getMember` in interface `BeanProperty`
      Specified by:
        `getMember` in class `SettableBeanProperty`

    - #### deserializeAndSet

          public void deserializeAndSet(JsonParser jp,
                               DeserializationContext ctxt,
                               Object instance)
                                 throws IOException,
                                        JsonProcessingException

      Description copied from class: `SettableBeanProperty`
      Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).
      Specified by:
        `deserializeAndSet` in class `SettableBeanProperty`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### set

          public void set(Object instance,
                 Object value)
                   throws IOException

      Specified by:
        `set` in class `SettableBeanProperty`
      Throws:
        `IOException`

    - #### getInjectableValueId

          public Object getInjectableValueId()

      Description copied from class: `SettableBeanProperty`
      Accessor for id of injectable value, if this bean property supports value injection.
      Overrides:
        `getInjectableValueId` in class `SettableBeanProperty`